Attribute VB_Name = "mod_Document_Tables2Excel_s4p"
Option Compare Database
Option Explicit
'
'  module: mod_Document_Tables2Excel_s4p
'*************** Code Start *****************************************************
' Purpose  : document table contents and structure. + Create ListOfTables, DataDictionary, Documentation_s4p
' Author   : crystal (strive4peace)
' License  : below code
' Code List: www.MsAccessGurus.com/code.htm
'          : http://msaccessgurus.com/VBA/Code/Document_Tables2Excel.htm
'
'  ALSO NEEDS:
'  VBA > Properties > Get and set ... read, write, show, delete
'   http://msaccessgurus.com/VBA/Code/Properties.htm
'
'  VBA > custom Function > GetDataType
'   http://msaccessgurus.com/VBA/Code/Fx_GetDataType.htm
'-------------------------------------------------------------------------------
'                              launch_Document_Tables2Excel
'-------------------------------------------------------------------------------
Public Sub launch_Document_Tables2Excel()

'  CLICK HERE and RUN!
'                          PRESS F5 or choose Run menu from menubar
   Document_Tables2Excel False
End Sub

'-------------------------------------------------------------------------------
'                              Document_Tables2Excel
'-------------------------------------------------------------------------------
Public Sub Document_Tables2Excel(Optional pbGetData As Boolean = False)
'210809 ...210820 strive4peace
'Document all tables in a database to a new Excel workbook
'
'CopyFromRecordset code originally written by NateO
'Sheet1 = ListOfTables
'Sheet2 = DataDictionary
'Sheet3 = Documentation
'subsequent sheets are table contents if if pbGetData=true
'columns are best-fit, and text is wrapped is it's long
'data filters are added and columns are frozen
'data has borders
'
' adds yymmdd-hhmm to filename -- so be sure to weed these out!

   'CALLs
   '  FormatSheet
   '  GetVerifySheetname
   '  Get_Property
   
   On Error GoTo Proc_Err

   'Dimension object variables - Late binding
   Dim rsData As Object _
         , oExcel As Object _
         , oWb As Object _
         , oWs As Object
         
   'Early binding for Excel - rsData is ADO
'   Dim rsData As Object _
         , oExcel As Excel.Application _
         , oWb As Excel.Workbook _
         , oWs As Excel.Worksheet
         
   Dim db As DAO.Database _
      , rsTable As DAO.Recordset _
      , oTdf As DAO.TableDef _
      , oFld As DAO.Field

   'Dimension regular variables
   Dim sSQL As String _
         , sFilename As String _
         , sFileThere As String _
         , sMsg As String _
         , sPath As String _
         , sPathFile As String _
         , sSheetname As String _
         , nRow As Long _
         , nRecords As Long _
         , nRecordsTotal As Long _
         , nEstWidth As Long _
         , iFields As Integer _
         , iTables As Integer _
         , iTable As Integer _
         , iField As Integer _
         , iNumSheets As Integer _
         , iMultiplier As Integer _
         , iOverheadSize As Integer _
         , i As Integer _
         , iPart As Integer _
         , booMsg As Boolean _
         , nTimerStart As Single _
         , vvalue As Variant
   
   Dim anRow1() As Long 'last row for each of the tabledefs on DataDictionary
   Dim anRow2() As Long 'last row for each of the tabledefs on DataDictionary
   Dim aTable() As String 'tablename for design hyperlink display text on ListOfTables

   nTimerStart = Timer()

   '--- sFilename
   'strip extension, replace space with underscore
   i = InStrRev(CurrentProject.Name, ".")

   If pbGetData <> True Then
      sFilename = "TableSummary_"
   Else
      sFilename = "Tables_"
   End If
      
   sFilename = sFilename _
      & Replace(Left(CurrentProject.Name, i - 1), " ", "_") _
      & "__" & Format(Now, "yymmdd-hhnn")
      
      
   '--- sPath
   sPath = CurrentProject.Path & "\strive4peace\" '210514
   'create folder if it doesn't yet exist
   If Dir(sPath, vbDirectory) = "" Then
      MkDir sPath
      DoEvents
   End If
   
   sPathFile = sPath & sFilename       'NOTE: doesn't include extension

      
   booMsg = False 'give message that workbook was created
   
   Set db = CurrentDb
   
   'see how many tables need to be documented
   iTables = 0
   iTable = 0
   iPart = 0 'for error handler
   
   sSQL = "SELECT o.Name AS TName " _
      & ", o.Type AS iType" _
      & ", Switch([Type]=1,'Table'" _
      & ",[Type]=4,'ODBC Table'" _
      & ",[Type]=6,'Linked Table') AS TType" _
      & " FROM MSysObjects AS o" _
      & " WHERE ( (o.Type In (1,4,6)) " _
      & " AND ( Left([Name],1) <>'~') " _
      & " AND ( Left([Name],4) <>'MSys') " _
      & " AND ( Right([Name],5) <>'_Data') )" _
      & " ORDER BY o.Name" _
      & ";"
   Set rsTable = db.OpenRecordset(sSQL, dbOpenSnapshot)
   
   With rsTable
      If Not .EOF Then
         'movelast not necessary since snapshot
         iTables = .RecordCount
         ReDim anRow1(1 To iTables)
         ReDim anRow2(1 To iTables)
         ReDim aTable(1 To iTables)
      Else
         MsgBox "No Tables", , "Aborting"
         GoTo Proc_Exit
      End If
   End With
   
   'create a new instance of an Excel application
   Set oExcel = CreateObject("Excel.Application.16")

   With oExcel
      .Visible = True 'let user see what is happening
      .EnableEvents = False 'don't run any code
      If pbGetData <> False Then
         iNumSheets = iTables + 3 'for ListOfTables, DataDictionary, Documentation
      Else
         iNumSheets = 3
      End If
      'save value
      i = .SheetsInNewWorkbook
      .SheetsInNewWorkbook = iNumSheets
      'Add a new Workbook
      Set oWb = .Workbooks.Add()
      'put old value back
      .SheetsInNewWorkbook = i
   End With

   
   'create rsData object
   Set rsData = CreateObject("ADODB.Recordset")
      
   '-------------------------------------------------------- Tables
   'pbGetData
   Do While Not rsTable.EOF

      'table name
      sSheetname = rsTable!TName
      
      'this shouldn't happen
      If Left(sSheetname, 4) = "MSys" Then GoTo NextTable
            
      sSQL = "SELECT t.* FROM [" & sSheetname & "] t"
         
      'truncate name to 30 characters for Excel (31 max)
      If pbGetData <> False And Len(sSheetname) > 30 Then
         sSheetname = Left(sSheetname, 30)
      End If
   
      'Open an ADODB.Recordset
      With rsData
         .CursorLocation = 3 'adUseClient
         'adOpenStatic = 3
         'adLockReadOnly = 1
         rsData.Open sSQL _
               , CodeProject.Connection _
               , 3 _
               , 1
   
         'count records
         nRecords = .RecordCount
         nRecordsTotal = nRecordsTotal + nRecords
         iFields = .Fields.Count
      End With
   
      iTable = iTable + 1
      aTable(iTable) = rsTable!TName
      
      'Worksheets Collection is 1-based
      'Table Index                                             2
      With oWb.Worksheets(1)
         .cells(iTable + 1, 1).Value = sSheetname
         .cells(iTable + 1, 2).Value = nRecords
         .cells(iTable + 1, 3).Value = iFields
      End With
      
      If pbGetData <> False Then
         Set oWs = oWb.Worksheets(iTable + 3)
         With oWs
            .Activate
            'Write Labels from Field Names
            For i = 1 To iFields
               .cells(1, i).Value = rsData.Fields(i - 1).Name
             Next i
      
            'Rename Individual Worksheet
            sSheetname = GetVerifySheetname(oWb, sSheetname)
            If sSheetname <> "" Then
               .Name = sSheetname
            Else
               sSheetname = .Name
            End If
            
            'write to ListOfTables -- this will be turned into a hyperlink
            oWb.Worksheets(1).cells(iTable + 1, 1).Value = sSheetname
            
            If nRecords > 0 Then
               iPart = 1
               'Copy our Current Recordset to A2
               'if there is a long text field, this will fail
               .Range("a2").CopyFromRecordset rsData
            End If
            iPart = 0
   
Sheet_EndWriteData:
            Call FormatSheet(oWs, iFields)
            
            'set margins, orientation, header
            With .PageSetup
              .PrintTitleRows = "1:1"
              .PrintTitleColumns = "A:A"
              .RightHeader = "&""Times New Roman,Italic""&10&A - " & Now() & " - &P/&N"
              .LeftMargin = oExcel.InchesToPoints(0.5)
              .RightMargin = oExcel.InchesToPoints(0.5)
              .TopMargin = oExcel.InchesToPoints(0.5)
              .BottomMargin = oExcel.InchesToPoints(0.5)
              .HeaderMargin = oExcel.InchesToPoints(0.3)
              .FooterMargin = oExcel.InchesToPoints(0.3)
              .CenterHorizontally = True
              .Orientation = 2 'xlLandscape
            End With
      
         End With   'Worksheet
   End If 'pbGetData
   
NextTable:
      rsData.Close
      rsTable.MoveNext
   Loop
   
   'done with all the tables
   
   '-------------------------------------------------------- Documentation
   iPart = 0
   Set oWs = oWb.Worksheets(3)
   nRow = 1
   With oWs
      .Activate
      .Name = "Documentation_s4p"
      iFields = 3
      
      'column headings
      Let .Range("a1").Resize(, 3).Value = _
         Array("Sheet", "ColumnName", "Note")
      
      '~~~ ListOfTables
      'select to add hyperlink
      .Range("A2").Select
      '(Anchor, Address, SubAddress, ScreenTip, TextToDisplay)
      With oExcel.Selection.Hyperlinks.Add( _
            oExcel.Selection _
            , "" _
            , "ListOfTables!A1" _
            , "go to list of tables" _
            , "ListOfTables")
      End With
      
      If pbGetData <> False Then
         Let .Range("B2").Resize(, 2).Value = Array("A. goto SheetName" _
            , "click to jump to sheet with Table data")
      Else
         Let .Range("B2").Resize(, 2).Value = Array("A. Table" _
            , "Table Name")
      End If
      
      Let .Range("b3").Resize(, 2).Value = Array("B. #Recs", "number of records")
      Let .Range("b4").Resize(, 2).Value = Array("C. #Flds", "number of fields")
      Let .Range("b5").Resize(, 2).Value = Array("D. EstWidth", "estimated record width, standard types only")
      Let .Range("b6").Resize(, 2).Value = Array("E. goto DataDictionary", "click to jump to table definition")

      .Range("A7").Select
      With oExcel.Selection.Hyperlinks.Add( _
            oExcel.Selection _
            , "" _
            , "DataDictionary!A1" _
            , "go to DataDictionary" _
            , "DataDictionary")
      End With

      '~~~ DataDictionary
      
      Let .Range("b7").Resize(, 2).Value = Array("A. Table", "Table name")
            
      Let .Range("b8").Resize(, 2).Value = Array("B. F#", "Field number")
      Let .Range("b9").Resize(, 2).Value = Array("C. Field", "Field name")
            
      Let .Range("b10").Resize(, 2).Value = Array("D. DataType", "Data Type")
      Let .Range("b11").Resize(, 2).Value = Array("E. Size", "Size (byte)")
         
      Let .Range("b12").Resize(, 2).Value = Array("F. Description", "Description")
      Let .Range("b13").Resize(, 2).Value = Array("G. Format", "Format")
            
      Let .Range("b14").Resize(, 2).Value = Array("H. Caption", "Caption")
      Let .Range("b15").Resize(, 2).Value = Array("I. DefaultValue", "Default Value")
         
      Let .Range("b16").Resize(, 2).Value = Array("J. Expression", "Expression")
      Let .Range("b17").Resize(, 2).Value = Array("K. InputMask", "Input Mask")
            
      Let .Range("b18").Resize(, 2).Value = Array("L. ValRule", "Validation Rule")
      Let .Range("b19").Resize(, 2).Value = Array("M. ValText", "Validation Text")
         
         
      Let .Range("b20").Resize(, 2).Value = Array("N. Req", "Required?")
      Let .Range("b21").Resize(, 2).Value = Array("O. UC", "Unicode Compression?")
            
      Let .Range("b22").Resize(, 2).Value = Array("P. EstW", "Estimated Width")
      Let .Range("b23").Resize(, 2).Value = Array("Q. SumEstW", "Sum of estimated width for standard fields in table. Won't be right if sort order is changed.")
      
      If pbGetData <> False Then
         'Tables
          .Range("a24").Resize(, 2).Value = Array("Tables" _
            , "tables with data on different sheets") ' _
            , "ListOfTables has hyperlinks to each sheet")
               
         .Range("C24").Select
         With oExcel.Selection.Hyperlinks.Add( _
               oExcel.Selection _
               , "" _
               , "ListOfTables!A1" _
               , "go to ListOfTables" _
               , "ListOfTables has hyperlinks")
         End With
      End If
      
      '0=don't wrap columns
      Call FormatSheet(oWs, iFields, 0)
      
      'attribution and link
      .cells(26, 1).Value = "This documentation made with Document Tables to Excel, from MsAccessGurus.com"
      
         .Range("a27").Select
         With oExcel.Selection.Hyperlinks.Add( _
               oExcel.Selection _
               , "http://msaccessgurus.com/VBA/Code/Document_Tables2Excel.htm" _
               , "" _
               , "Get VBA to make this documentation" _
               , "http://msaccessgurus.com/VBA/Code/Document_Tables2Excel.htm")
         End With

   End With
   
   '-------------------------------------------------------- DataDictionary
   'TableDefs ' sheet2 is tabledefs - fields + properties
   
   Set oWs = oWb.Worksheets(2)
   With oWs
      .Activate
      .Name = "DataDictionary"
      
      iFields = 17
      .cells(1, 1).Value = "Table"
      .cells(1, 2).Value = "F#"
      .cells(1, 3).Value = "Field"
      .cells(1, 4).Value = "DataType"
      .cells(1, 5).Value = "Size"
      .cells(1, 6).Value = "Description"
      .cells(1, 7).Value = "Format"
      .cells(1, 8).Value = "Caption"
      .cells(1, 9).Value = "DefaultValue"
      .cells(1, 10).Value = "Expression"
      .cells(1, 11).Value = "InputMask"
      .cells(1, 12).Value = "ValRule"
      .cells(1, 13).Value = "ValText"
      .cells(1, 14).Value = "Req"
      .cells(1, 15).Value = "UC"
      .cells(1, 16).Value = "EstW"
      .cells(1, 17).Value = "SumEst"
      
      rsTable.MoveFirst
      nRow = 2 'labels in 1
      anRow1(1) = nRow ' first row
      
      iTable = 0
      iField = 0
      Do While Not rsTable.EOF
         Set oTdf = db.TableDefs(rsTable!TName)
         nEstWidth = 0
         iTable = iTable + 1
                   
         'loop fields
         For Each oFld In oTdf.Fields
            iField = oFld.OrdinalPosition
            iMultiplier = 1
            iOverheadSize = 0
            
            .cells(nRow, 1).Value = rsTable!TName
            .cells(nRow, 2).Value = iField 'F#
            
            .cells(nRow, 3).Value = oFld.Name
            .cells(nRow, 4).Value = GetDataType(oFld.Type)
            .cells(nRow, 5).Value = oFld.Size
            
            'Description
            vvalue = Null
            vvalue = Get_Property("Description", oFld, "")
            If vvalue <> "" Then
               .cells(nRow, 6).Value = vvalue
            End If
            
            'Format
            vvalue = Null
            vvalue = Get_Property("Format", oFld, "")
            If vvalue <> "" Then
               .cells(nRow, 7).Value = vvalue
            End If
            
            'Caption
            vvalue = Null
            vvalue = Get_Property("Caption", oFld, "")
            If vvalue <> "" Then
               .cells(nRow, 8).Value = vvalue
            End If
            
            'DefaultValue
            vvalue = Null
            vvalue = Get_Property("DefaultValue", oFld, "")
            If vvalue <> "" Then
               .cells(nRow, 9).Value = "'" & vvalue
            End If

            'Expression
            vvalue = Null
            vvalue = Get_Property("Expression", oFld, "")
            If vvalue <> "" Then
               .cells(nRow, 10).Value = "'" & vvalue
            End If

            'InputMask
            vvalue = Null
            vvalue = Get_Property("InputMask", oFld, "")
            If vvalue <> "" Then
               .cells(nRow, 11).Value = vvalue
            End If
            
            'ValidationRule
            vvalue = Null
            vvalue = Get_Property("ValidationRule", oFld, "")
            If vvalue <> "" Then
               .cells(nRow, 12).Value = "'" & vvalue
            End If

            'ValidationText
            vvalue = Null
            vvalue = Get_Property("ValidationText", oFld, "")
            If vvalue <> "" Then
               .cells(nRow, 13).Value = "'" & vvalue
            End If
                        
            'Required
            vvalue = Null
            vvalue = Get_Property("Required", oFld, False)
            If CBool(Nz(vvalue, False)) = True Then
               .cells(nRow, 14).Value = "R"
            End If
            
            'UnicodeCompression
            If oFld.Type = 10 Or oFld.Type = 12 Then
            
               vvalue = Null
               vvalue = Get_Property("UnicodeCompression", oFld, False)
               
               If CBool(Nz(vvalue, False)) <> True Then   'no unicode compression
                  .cells(nRow, 15).Value = "No"
                  iMultiplier = 2
               Else
                  .cells(nRow, 15).Value = "+"
               End If

               'If oFld.Type = 10 Then iOverheadSize = 10 'just a guess! it's something ... Int, Byte, etc may count word space instead
            End If
            
            .cells(nRow, 16).Value = (oFld.Size * iMultiplier) + iOverheadSize 'provisioning for overhead
            
            nEstWidth = nEstWidth + (oFld.Size * iMultiplier) + iOverheadSize
            nRow = nRow + 1
         Next oFld
   
         'done with table
         'record last row for table
         If iTable <= iTables Then
            anRow2(iTable) = nRow - 1
         End If
         
         
         'first row for next table
         If iTable < iTables Then
            anRow1(iTable + 1) = nRow
         End If
         
         'could also put hyperlink to DD

         'write width  to summary sheet
         oWb.Worksheets(1).cells(iTable + 1, 4).Value = nEstWidth
         'write formula to add it up on this sheet
         With .cells(anRow1(iTable), 17) '17=Q
            .Formula = "=SUM(P" & anRow1(iTable) _
               & ":P" & anRow2(iTable) & ")"
         End With

         rsTable.MoveNext
      Loop
      
      'last row for last table
      anRow2(UBound(aTable)) = nRow
      
      '#cols=iFields
      'MaxWidth=40
      'True=Add Borders
      'D2=ActiveCell -- use for FreezePanes
      
      Call FormatSheet(oWs, iFields, 40, True, "D2")
      
      For i = LBound(anRow1) To UBound(anRow1)
         'bold tablename in first row
         oWs.cells(anRow1(i), 1).Font.Bold = True
      Next i

   End With

   '-------------------------------------------------------- ListOfTables
   Set oWs = oWb.Worksheets(1) '1st sheet is list of tables
   With oWs
      .Activate
      .Name = "ListOfTables"

      If pbGetData <> False Then 'true
         .cells(1, 1).Value = "Sheet_Table"
      Else
         .cells(1, 1).Value = "Table"
      End If
      
      .cells(1, 2).Value = "#Recs"
      .cells(1, 3).Value = "#Flds"
      .cells(1, 4).Value = "EstWidth"
      .cells(1, 5).Value = "goto DataDictionary"

      iFields = 5
   
      'hyperlinks
      For i = 1 To iTables
         
         If pbGetData <> False Then 'has Table data sheets
         
            .Range("A" & (i + 1)).Select
            sSheetname = oExcel.ActiveCell.Value
            
            '(Anchor, Address, SubAddress, ScreenTip, TextToDisplay)
            .Hyperlinks.Add _
               oExcel.Selection _
               , "" _
               , sSheetname & "!A1" _
               , "Goto " & sSheetname _
               , sSheetname
         End If
         
         
         .Range("E" & (i + 1)).Select
         
         '(Anchor, Address, SubAddress, ScreenTip, TextToDisplay)
         
         .Hyperlinks.Add _
            oExcel.Selection _
            , "" _
            , "DataDictionary!A" & anRow1(i) _
            , "Definition " & sSheetname _
            , aTable(i) 'table name NOT Truncated
      Next i
            
      Call FormatSheet(oWs, iFields, 0, , , nRow)

      'Add note to end of ListOfTables
      With .cells(nRow + 2, 1)
         .Value = "After going to a link and only scrolling, " _
               & " press Ctrl-G, ENTER " _
               & " to Go back to previous ActiveCell."
         .WrapText = True
         .Font.Italic = True
      End With
      
      'final leave
      .Range("A1").Select
   End With

CheckFile:
   'delete file if it already exists
   sFileThere = Dir(sPathFile & ".xls*")
   If sFileThere <> "" Then
      On Error Resume Next
      DoEvents
      sFileThere = sPath & sFileThere
      Kill sFileThere
      DoEvents
      iPart = 9
      On Error GoTo Proc_Err
      If Dir(sFileThere) <> "" Then
         'file is still there
         sMsg = "can't save file: " _
            & sFilename _
            & vbCrLf & "in path: " & sPath _
            & vbCrLf & vbCrLf & "If the file is OPEN," _
            & " then CLOSE it and click Yes to replace." _
            & vbCrLf & vbCrLf & "Yes = close file manually & replace it." _
            & vbCrLf & "No = don't save"
            
         If MsgBox(sMsg, vbYesNo + vbDefaultButton2 _
            , "Close file manually and replace it?") _
            = vbNo Then
            GoTo Proc_Exit
         Else
            'close file manually
            DoEvents
            GoTo CheckFile
         End If
      End If
   End If
 
   iPart = 9
      
   '(FileName, FileFormat, Password, WriteResPassword _
   , ReadOnlyRecommended, CreateBackup, AccessMode, ConflictResolution _
   , AddToMru, TextCodepage, TextVisualLayout, Local)
   'XlSaveConflictResolution : xlLocalSessionChanges=2
   
   'XlFileFormat : xlWorkbookDefault=51
   oWb.SaveAs sPathFile
   DoEvents
   iPart = 0
   
   'close workbook,  save
   With oWb
      .Close True, sPathFile
   End With
   
   booMsg = True
   
Proc_Exit:
   On Error Resume Next
   If Not booMsg Then
      oWb.Close False
      Set oWb = Nothing
   End If
   
Proc_Exit2:
   On Error Resume Next
   If Not rsData Is Nothing Then
      rsData.Close
      Set rsData = Nothing
   End If
   If Not rsTable Is Nothing Then
      rsTable.Close
      Set rsTable = Nothing
   End If
   Set db = Nothing

   If TypeName(oExcel) <> "Nothing" Then
      oExcel.Quit
      Set oExcel = Nothing
   End If
   If booMsg Then
      '210514
      
      sMsg = "OK =  open folder" _
            & vbCrLf & "Cancel = (Esc) Don't open anything" _
            & vbCrLf & vbCrLf & "File is created whether you look or not." _
            & vbCrLf & "Remember to delete files you no longer want to look at."
            
      sMsg = sPathFile _
         & vbCrLf & vbCrLf & " has been created" _
         & vbCrLf & vbCrLf & nRecordsTotal & " Records" _
         & " in " & iTables & " tables" _
         & vbCrLf & vbCrLf & "Time to execute: " _
         & Format(Timer - nTimerStart, "#,###.##") & " seconds" _
         & vbCrLf & vbCrLf & sMsg
            
      Select Case MsgBox(sMsg, vbOKCancel, "Done")
         
      Case vbOK ' open  folder
         Application.FollowHyperlink sPath
         
      End Select
   End If

   Exit Sub
 
Proc_Err:
   If iPart = 1 Then ' -non-standard data types -- probably can't CopyFromRecordset
      oWs.cells(2, 3) = "has non-standard data type(s) -- can't CopyFromRecordset"
      Resume Sheet_EndWriteData
   ElseIf iPart = 9 Then
      'filename not valid
      sMsg = "Filename: " & sPathFile _
         & vbCrLf & "isn't valid"
      Debug.Print sMsg
      MsgBox sMsg, , "Exiting"
      iPart = 0
         
      Resume Proc_Exit2
   End If
   
   MsgBox Err.Description _
         , , "ERROR " & Err.Number _
         & "   Document_Tables2Excel"

'Stop  'use if code won't break

   Resume Proc_Exit
   Resume
End Sub

'-------------------------------------------------------------------------------
'                              FormatSheet
'-------------------------------------------------------------------------------
'  helper for Document_Tables2Excel
Private Sub FormatSheet(pWs As Object _
   , Optional piNumColumns As Integer = -99 _
   , Optional piMaxWidth As Integer = 60 _
   , Optional pBorder As Boolean = True _
   , Optional psActiveCell As String = "B2" _
   , Optional pRETURNLastRow As Long _
   )
'210811 strive4peace ... 210823
   'piMaxWidth=0 if you don't want to wrap
' send variable for pRETURNLastRow if you want to get the last row back

   Dim nCol As Long _
      , bWrap As Boolean _
      , i As Integer
   
   bWrap = False
   
   With pWs
      pRETURNLastRow = .cells(.Rows.Count, 1).End(-4162).Row  'xlUp=-4162
      If piNumColumns < 0 Then
         'calculate number of columns if not passed
         piNumColumns = .cells(1, .Columns.Count).End(-4159).Column 'xlToLeft=-4159
      End If
      
      With .cells.Font
          .Name = "Calibri"
          .Size = 12
      End With
        
      With .Range(.cells(1, 1), .cells(1, piNumColumns))
         .Font.Size = 10
         With .Interior
            .Color = RGB(225, 225, 225)
         End With
      End With
      
      .Range(psActiveCell).Select
      
      'AutoFilter
      .Application.Selection.AutoFilter
      
      'best-fit columns
      .cells.EntireColumn.AutoFit
      
      If piMaxWidth > 0 Then
         For nCol = 1 To piNumColumns
            'if any column widths > piMaxWidth, Wrap Text
            If .Columns(nCol).ColumnWidth > 60 Then
               .Columns(nCol).ColumnWidth = 60
               .Columns(nCol).WrapText = True
               bWrap = True
            End If
         Next nCol
      End If

      If bWrap <> False Then
         .cells.EntireRow.AutoFit
      End If
      
      If pRETURNLastRow > 0 And piNumColumns > 0 Then
         'xlDiagonalDown 5
         'xlDiagonalUp 6
         'xlEdgeLeft 7
         'xlEdgeTop 8
         'xlEdgeBottom 9
         'xlEdgeRight 10
         'xlInsideVertical 11
         'xlInsideHorizontal 12
         
         With .Range(.cells(1, 1), .cells(pRETURNLastRow, piNumColumns))
            For i = 7 To 12
               With .Borders(i)
                  .LineStyle = 1 'xlContinuous
                  .Color = RGB(150, 150, 150)
                  .Weight = 1 'xlHairline
               End With
            Next i
'            .VerticalAlignment = -4108 'xlCenter
            .VerticalAlignment = -4160 'xlVAlignTop
         End With
      End If
      
      'FreezePanes
      .Application.ActiveWindow.FreezePanes = True
   End With

   
End Sub

'-------------------------------------------------------------------------------
'                              GetVerifySheetname
'-------------------------------------------------------------------------------

Function GetVerifySheetname(pOWb As Object _
, psSheetname As String _
   , Optional pReturnTries As Integer _
   ) As String
'210814 strive4peace
'Return a unique sheet name with 31 characters from a name 30 characters
'if = "" then nothing works -- so don't rename
   
   GetVerifySheetname = ""
   
   On Error Resume Next
   
   'this will work from 1 to 9 copies
   Dim sSheetname As String _
      , sTest As String
      
   GetVerifySheetname = psSheetname
   sSheetname = psSheetname 'assume its ok
   pReturnTries = 0 'name didn't get modified

   'if name duplicated, add 1-9 to end
   'name is 30 characters
   'sheet name limit is 31 characters
   For pReturnTries = 0 To 8
      GetVerifySheetname = sSheetname
      
      'if name is  already there, this won't be error
      sTest = pOWb.Sheets(sSheetname).Name
   
      If Err.Number <> 0 Then
         'this name is ok! Doesn't exist
         GoTo Proc_Exit
      End If
      
      'try next number
      sSheetname = psSheetname & (pReturnTries + 1)
   
   Next pReturnTries

   'use letters of alphabet

   'if name duplicated, add A-Z to end
   For pReturnTries = 10 To 36
      GetVerifySheetname = sSheetname '1st test is from numbers
      sTest = pOWb.Sheets(sSheetname).Name
      If Err.Number <> 0 Then
         'name ok
         GoTo Proc_Exit
      End If
      
      'try next letter. after Z is [ but it won't get tested
      sSheetname = psSheetname & Chr(65 - 10 + pReturnTries + 1)
   
   Next pReturnTries

   'nothing works -- so don't rename
   GetVerifySheetname = ""
      
     
Proc_Exit:
   On Error Resume Next
   Exit Function
  
End Function


' LICENSE
'  Only use this code if you have rights to get this information.
'   You may freely use and share this code
'     provided this license notice and comment lines are not changed;
'     code may be modified provided you clearly note your changes.
'   You may not sell this code alone, or as part of a collection,
'     without my handwritten permission.
'   All ownership rights reserved. Use at your own risk.
'   ~ crystal (strive4peace)  www.MsAccessGurus.com
'*************** Code End *******************************************************
